# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from playbookmedia_backend_client_sdk.models.comment_thread import CommentThread
from playbookmedia_backend_client_sdk.models.document_snapshot import DocumentSnapshot
from playbookmedia_backend_client_sdk.models.file_embeddings import FileEmbeddings
from playbookmedia_backend_client_sdk.models.file_sharing import FileSharing
from playbookmedia_backend_client_sdk.models.file_version import FileVersion
from typing import Optional, Set
from typing_extensions import Self

class FileMetadata(BaseModel):
    """
    FileMetadata
    """ # noqa: E501
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    size: Optional[StrictStr] = None
    s3_key: Optional[StrictStr] = Field(default=None, alias="s3Key")
    s3_bucket_name: Optional[StrictStr] = Field(default=None, alias="s3BucketName")
    is_deleted: Optional[StrictBool] = Field(default=None, alias="isDeleted")
    version: Optional[StrictInt] = None
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    deleted_at: Optional[datetime] = Field(default=None, alias="deletedAt")
    embeddings: Optional[FileEmbeddings] = None
    versions: Optional[List[FileVersion]] = None
    comments: Optional[List[CommentThread]] = None
    sharing: Optional[List[FileSharing]] = None
    snapshots: Optional[List[DocumentSnapshot]] = None
    __properties: ClassVar[List[str]] = ["id", "name", "size", "s3Key", "s3BucketName", "isDeleted", "version", "createdAt", "updatedAt", "deletedAt", "embeddings", "versions", "comments", "sharing", "snapshots"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FileMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of embeddings
        if self.embeddings:
            _dict['embeddings'] = self.embeddings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in versions (list)
        _items = []
        if self.versions:
            for _item in self.versions:
                if _item:
                    _items.append(_item.to_dict())
            _dict['versions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in comments (list)
        _items = []
        if self.comments:
            for _item in self.comments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['comments'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in sharing (list)
        _items = []
        if self.sharing:
            for _item in self.sharing:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sharing'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in snapshots (list)
        _items = []
        if self.snapshots:
            for _item in self.snapshots:
                if _item:
                    _items.append(_item.to_dict())
            _dict['snapshots'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FileMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "size": obj.get("size"),
            "s3Key": obj.get("s3Key"),
            "s3BucketName": obj.get("s3BucketName"),
            "isDeleted": obj.get("isDeleted"),
            "version": obj.get("version"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "deletedAt": obj.get("deletedAt"),
            "embeddings": FileEmbeddings.from_dict(obj["embeddings"]) if obj.get("embeddings") is not None else None,
            "versions": [FileVersion.from_dict(_item) for _item in obj["versions"]] if obj.get("versions") is not None else None,
            "comments": [CommentThread.from_dict(_item) for _item in obj["comments"]] if obj.get("comments") is not None else None,
            "sharing": [FileSharing.from_dict(_item) for _item in obj["sharing"]] if obj.get("sharing") is not None else None,
            "snapshots": [DocumentSnapshot.from_dict(_item) for _item in obj["snapshots"]] if obj.get("snapshots") is not None else None
        })
        return _obj


