# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from playbookmedia_backend_client_sdk.models.tenant_api_key_scope import TenantAPIKeyScope
from playbookmedia_backend_client_sdk.models.v1_status import V1Status
from typing import Optional, Set
from typing_extensions import Self

class TenantAPIKey(BaseModel):
    """
    TenantAPIKey
    """ # noqa: E501
    id: Optional[StrictStr] = None
    key_hash: Optional[StrictStr] = Field(default=None, alias="keyHash")
    key_prefix: Optional[StrictStr] = Field(default=None, alias="keyPrefix")
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    status: Optional[V1Status] = V1Status.UNSPECIFIED
    scopes: Optional[List[TenantAPIKeyScope]] = None
    max_uses: Optional[StrictInt] = Field(default=None, alias="maxUses")
    allowed_ips: Optional[List[StrictStr]] = Field(default=None, alias="allowedIps")
    use_count: Optional[StrictInt] = Field(default=None, alias="useCount")
    expires_at: Optional[datetime] = Field(default=None, alias="expiresAt")
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    deleted_at: Optional[datetime] = Field(default=None, alias="deletedAt")
    __properties: ClassVar[List[str]] = ["id", "keyHash", "keyPrefix", "name", "description", "status", "scopes", "maxUses", "allowedIps", "useCount", "expiresAt", "createdAt", "updatedAt", "deletedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TenantAPIKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TenantAPIKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "keyHash": obj.get("keyHash"),
            "keyPrefix": obj.get("keyPrefix"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "status": obj.get("status") if obj.get("status") is not None else V1Status.UNSPECIFIED,
            "scopes": obj.get("scopes"),
            "maxUses": obj.get("maxUses"),
            "allowedIps": obj.get("allowedIps"),
            "useCount": obj.get("useCount"),
            "expiresAt": obj.get("expiresAt"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "deletedAt": obj.get("deletedAt")
        })
        return _obj


